{-----------------------------------------------------------------------------
   Unit Name: editprj
   Purpose  : Unit for editing FollowProjectItem
   Author   : Vesa Lappalainen
   Date     : 27.12.1997
   Changed  :
   Todo     :
-----------------------------------------------------------------------------}

unit editprj;

interface

uses
  SysUtils, Classes,
{$ifdef CLX}
  QGraphics, QControls, QForms, QDialogs, QStdCtrls, QExtCtrls,
{$else}
  Windows, Messages,
  Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls,
{$endif}
  follitem, savepos;

type
  TEditProject = class(TForm)
    PanelBase: TPanel;
    PanelButtons: TPanel;
    PanelButtonsInside: TPanel;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    EditMainID: TEdit;
    Panel2: TPanel;
    Label2: TLabel;
    EditSubID: TEdit;
    Panel3: TPanel;
    Label3: TLabel;
    EditExpl: TEdit;
    Panel4: TPanel;
    Label4: TLabel;
    EditProg: TEdit;
    Panel5: TPanel;
    Label5: TLabel;
    EditLevel: TEdit;
    SavePos1: TSavePos;
  private
    { Private declarations }
    Item : TFollowProjectItem;
  public
    { Public declarations }
    function Edit(AItem:TFollowProjectItem; const s:string) : integer;
  end;

var
  EditProject: TEditProject;

implementation

{$ifdef CLX}
{$R *.xfm}
{$else}
{$R *.dfm}
{$endif}

function TEditProject.Edit(AItem:TFollowProjectItem; const s:string) : integer;
begin
  ButtonOK.Align := alRight;
  Item := AItem;
  Result := mrCancel;
  if ( Item = nil ) then exit;
  with Item do begin
    EditMainId.Text := MainId;
    EditSubId.Text  := SubId;
    EditExpl.Text   := Expl;
    EditLevel.Text  := IntToStr(Level);
    EditProg.Text   := Prog;
    Caption         := s;
    Result := ShowModal;
    if ( Result = mrCancel ) then exit;
    MainId := EditMainId.Text;
    SubId  := EditSubId.Text;
    Expl   := EditExpl.Text;
    Level  := StrToIntDef(EditLevel.Text,1);
    Prog   := EditProg.Text;
  end;
end;

end.
