{-----------------------------------------------------------------------------
   Unit Name: filelist
   Purpose  : Unit to for different filetypes with some view property
   Author   : Vesa Lappalainen
   Date     : 27.12.1997
   Changed  :
   Todo     :
-----------------------------------------------------------------------------}

unit filelist;

interface

uses sysutils,Types,
{$ifdef CLX}
  QStdCtrls,QComCtrls,
{$else}
  StdCtrls,ComCtrls,
{$endif}
  fileobj;

type
  TFileList = class(TFileObjects)
    Fcb : TListView;
    LastSort : integer;
  public
    constructor Create3(AType:TFileObjectType;const AName:string; Acb:TListView);
    function Update:boolean; override;
    procedure ListViewColumnClick(Sender: TObject;Column: TListColumn);
    procedure UpdateLine(li:TListItem);
    procedure DoSort(i:integer);
  published
    property cb : TListView read Fcb write Fcb;
  end;



implementation

//------------------------------------------------------------------------------
// TFileCombo
//------------------------------------------------------------------------------
constructor TFileList.Create3(AType:TFileObjectType;const AName:string;
                               Acb:TListView);
begin
  Fcb := Acb;
  Create2(AType,AName);
end;
{
function TFollowProjectFile.InformNew(o:TFileObject):boolean;
begin
  Result := true;
  if ( not Assigned(cb) ) then exit;
  cb.Items.Add(o.ShowStr);
end;
}

procedure SetItem(li:TListItem;Obj:TFileObject);
var j:integer;
begin
  li.SubItems.Clear;
  li.Caption := Obj.Items[0];
  li.Data := Obj;
  for j:=1 to Obj.ItemCount-1 do
    li.SubItems.Add(Obj.Items[j]);
end;

function TFileList.Update:boolean;
var j,i:integer;   ListItem: TListItem; NewColumn: TListColumn;
    w : array[0..50] of integer;
begin
  Result := false;
  if ( not Assigned(cb) ) then exit;
  cb.OnColumnClick := ListViewColumnClick;
  cb.Items.Clear;
{$ifdef CLX}
  for j:=0 to 50 do w[j] := 100;
{$else}
  for j:=0 to 50 do w[j] := ColumnTextWidth;
  cb.AllocBy := Count;
{$endif}

  for j:=0 to cb.Columns.Count-1 do w[j] := cb.Columns[j].Width;
  cb.Columns.Clear;
  for j:=0 to IType.ItemCount-1 do begin
    NewColumn := cb.Columns.Add;
    NewColumn.Caption := IType.GetHead(j);
//    NewColumn.Width := w[j];
  end;

  for i:=0 to Count-1 do begin
    ListItem := cb.Items.Add;
    SetItem(ListItem,obj[i]);
  end;

  Result := true;

  for j:=0 to IType.ItemCount-1 do begin
    cb.Columns[j].Width := w[j];
  end;

  DoSort(LastSort);
end;

procedure TFileList.UpdateLine(li:TListItem);
begin
  SetItem(li,li.Data);
  DoSort(LastSort);
end;

function CompFunc(lParam1, lParam2, lParamSort: Integer): Integer stdcall;
var i1,i2 : TFileObject;
begin
  i1 := TFileObject(TListItem(lParam1).Data);
  i2 := TFileObject(TListItem(lParam2).Data);
  Result := i1.Compare(i2,lParamSort);
end;

procedure TFileList.DoSort(i:integer);
begin
  LastSort := i;
{$ifdef CLX}

{$else}
  cb.CustomSort(@CompFunc,i);
{$endif}
end;

procedure TFileList.ListViewColumnClick(Sender: TObject; Column: TListColumn);
begin
  DoSort(Column.Index);
end;


end.
