{-----------------------------------------------------------------------------
   Unit Name: foptions
   Purpose  : Options form for TimeFollow
   Author   : Vesa Lappalainen
   Date     : 26.12.1997
   Changed  :
   Todo     :
-----------------------------------------------------------------------------}

unit foptions;

interface

uses
  SysUtils, Classes,
{$ifdef CLX}
  QGraphics, QControls, QForms, QDialogs, QExtCtrls, QStdCtrls,
{$else}
  Windows, Messages,
  Graphics, Controls, Forms, Dialogs, ExtCtrls, StdCtrls,
{$endif}
   kinicomp, savepos, inifiles,ininame;
type
  TOptions = class(TForm)
    Panel1: TPanel;
    OpenDialog: TOpenDialog;
    SavePos1: TSavePos;
    PanelLeftMargin: TPanel;
    PanelOptions: TPanel;
    PanelButtons: TPanel;
    Panel3: TPanel;
    Label2: TLabel;
    TimeName: TEditIni;
    ButtonTime: TButton;
    Panel2: TPanel;
    Label1: TLabel;
    ProjectName: TEditIni;
    ButtonPrj: TButton;
    Panel4: TPanel;
    Label3: TLabel;
    TempName: TEditIni;
    ButtonTmp: TButton;
    ButtonOK: TButton;
    AutoProj: TCheckBoxIni;
    AutoStop: TCheckBoxIni;
    VerifyAdd: TCheckBoxIni;
    DecimalSep: TEditIni;
    Label4: TLabel;
    procedure ButtonPrjClick(Sender: TObject);
    procedure ButtonTimeClick(Sender: TObject);
    procedure ButtonTmpClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DecimalSepChange(Sender: TObject);
  private
    { Private declarations }
//    FIni : TIniFile;
    OrigSeparator : Char;
  public
    { Public declarations }
//    property Ini : TIniFile read FIni;
  end;

var
  Options: TOptions;

implementation
uses kstring;
{$ifdef CLX}
{$R *.xfm}
{$else}
{$R *.dfm}
{$endif}


procedure TOptions.ButtonPrjClick(Sender: TObject);
begin
  OpenDialog.FileName := ProjectName.Text;
  OpenDialog.Filter := 'Project files|*.pro|All files|*.*';
  OpenDialog.Title := 'Select project file';
  if ( not OpenDialog.Execute ) then exit;
  ProjectName.Text := OpenDialog.FileName;
end;

procedure TOptions.ButtonTimeClick(Sender: TObject);
begin
  OpenDialog.FileName := TimeName.Text;
  OpenDialog.Filter := 'Time files|*.tim|All files|*.*';
  OpenDialog.Title := 'Select time file';
  if ( not OpenDialog.Execute ) then exit;
  TimeName.Text := OpenDialog.FileName;
end;

procedure TOptions.ButtonTmpClick(Sender: TObject);
begin
  OpenDialog.FileName := TempName.Text;
  OpenDialog.Filter := 'Temp files|*.tmp|All files|*.*';
  OpenDialog.Title := 'Select temporary file';
  if ( not OpenDialog.Execute ) then exit;
  TempName.Text := OpenDialog.FileName;
end;

procedure TOptions.FormCreate(Sender: TObject);
begin
//  FIni := TIniFile.Create(GetIniName(''));
  ButtonOK.Align := alRight;
  OrigSeparator := DecimalSeparator;
  if DecimalSep.Text <> '' then
    DecimalSeparator := Char(DecimalSep.Text[1]);
end;

procedure TOptions.FormDestroy(Sender: TObject);
begin
//  FIni.UpdateFile;
//  FIni.Free;
end;

procedure TOptions.DecimalSepChange(Sender: TObject);
begin
  if DecimalSep.Text <> '' then
    DecimalSeparator := Char(DecimalSep.Text[1])
  else
    DecimalSeparator := OrigSeparator;
end;

end.
