unit timconv;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, ToolWin, ComCtrls, ExtCtrls, Menus, Grids, DBGrids,
  StdCtrls, DBCtrls,follitem,filecomb,fileobj;

type
  TFormTimeConv = class(TForm)
    Query: TQuery;
    DataSource1: TDataSource;
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Options1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    QueryMainID: TStringField;
    QuerySubID: TStringField;
    QueryStart: TDateTimeField;
    QueryStop: TDateTimeField;
    QueryDiff: TFloatField;
    QueryExpl: TStringField;
    QueryWeek: TSmallintField;
    QueryDay: TSmallintField;
    PageControl1: TPageControl;
    TabAll: TTabSheet;
    Panel1: TPanel;
    DBGrid1: TDBGrid;
    ToolBar1: TToolBar;
    ButtonClose: TButton;
    ButtonRead: TButton;
    DBNavigator1: TDBNavigator;
    TabSheetWeek: TTabSheet;
    ToolBar2: TToolBar;
    DBGrid2: TDBGrid;
    MemoWeek: TMemo;
    QWeek: TQuery;
    DataSource2: TDataSource;
    ButtonSubmit: TButton;
    procedure Options1Click(Sender: TObject);
    procedure ButtonCloseClick(Sender: TObject);
    procedure ButtonReadClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure QueryPostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonSubmitClick(Sender: TObject);
  private
    projects : TFileObjects;
    times : TFileObjects;
    procedure ClearForm;
    procedure DoWeek;
    function OnAdd(sender:TFileObjects;o:TFileObject):boolean;
  public
    procedure InitForm;
  end;

var
  FormTimeConv: TFormTimeConv;

implementation
uses foptions,kdate;

{$R *.DFM}
//------------------------------------------------------------------------------
function TFormTimeConv.OnAdd(sender:TFileObjects;o:TFileObject):boolean;
var ot : TFollowTimeItem;
begin
  Result := false;
//  if ( Query.RecordCount > 0 ) then exit;
  if not ( o is TFollowTimeItem ) then exit;
  ot := o as TFollowTimeItem;
  Query.Append;
  QueryMainId.AsString := ot.MainId;
  QuerySubId.AsString := ot.SubId;
  QueryWeek.AsInteger := WeekNoOfDate(ot.DStart);
  QueryDay.AsInteger := DayOfWeek(ot.DStart);
  QueryStart.AsFloat := ot.DStart;
  QueryStop.AsFloat := ot.DStop;
  QueryDiff.AsFloat := ot.DDiff * 60 * 24;
  QueryExpl.AsString := ot.Expl;
  try
    Query.Post
  except
    Query.Cancel; 
  end;
end;

//------------------------------------------------------------------------------
// TFormTimeConv
//------------------------------------------------------------------------------

procedure TFormTimeConv.ClearForm;
begin
  if ( projects <> nil ) then projects.Free;  projects := nil;
  if ( times    <> nil ) then times.Free;     times    := nil;
end;

procedure TFormTimeConv.InitForm;
begin
  ClearForm;
  times := TFileObjects.Create2(TFollowTimeItem,Options.TimeName.Text);
  times.OnAdd := OnAdd;
  StatusBar1.Panels[0].Text := Options.TimeName.Text;
end;


procedure TFormTimeConv.Options1Click(Sender: TObject);
begin
  Options.ShowModal;
  InitForm;
end;

procedure TFormTimeConv.ButtonCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TFormTimeConv.ButtonReadClick(Sender: TObject);
begin
  Times.ReadFromFile('');
end;

procedure TFormTimeConv.FormDestroy(Sender: TObject);
begin
  ClearForm;
end;

procedure TFormTimeConv.QueryPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
begin
  Action := daAbort;
end;

procedure TFormTimeConv.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TFormTimeConv.FormCreate(Sender: TObject);
begin
  MemoWeek.Lines := QWeek.SQL;
  DoWeek;
end;

procedure TFormTimeConv.DoWeek;
var i:integer;
begin
  QWeek.Close;
  QWeek.SQL.Clear;
  QWeek.SQL := MemoWeek.Lines;
  QWeek.Open;
  for i:=0 to QWeek.FieldCount-1 do
    if QWeek.Fields[i] is TFloatField then
      (QWeek.Fields[i] as TFloatField).DisplayFormat := '0.0';
end;

procedure TFormTimeConv.ButtonSubmitClick(Sender: TObject);
begin
  DoWeek;
end;

end.
